"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _apolloBoost = _interopRequireDefault(require("apollo-boost"));

var _reactHooks = require("@apollo/react-hooks");

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var WrappedApolloProvider = function WrappedApolloProvider(_ref) {
  var children = _ref.children,
      _ref$shopName = _ref.shopName,
      shopName = _ref$shopName === void 0 ? {} : _ref$shopName,
      _ref$accessToken = _ref.accessToken,
      accessToken = _ref$accessToken === void 0 ? {} : _ref$accessToken,
      _ref$apiVersion = _ref.apiVersion,
      apiVersion = _ref$apiVersion === void 0 ? null : _ref$apiVersion;
  var client = new _apolloBoost["default"]({
    fetch: _isomorphicFetch["default"],
    uri: "https://".concat(shopName, ".myshopify.com/api/").concat(apiVersion ? "".concat(apiVersion, "/") : "", "graphql.json"),
    headers: {
      "X-Shopify-Storefront-Access-Token": accessToken
    }
  });
  return _react["default"].createElement(_reactHooks.ApolloProvider, {
    client: client
  }, children);
};

var _default = (0, _react.memo)(WrappedApolloProvider);

exports["default"] = _default;