"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _store = _interopRequireDefault(require("store/dist/store.modern"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Authentication = function Authentication(authConfig, firebaseApp) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, Authentication);
  (0, _defineProperty2["default"])(this, "fetchEmailSignInMethods", function (storedEmail) {
    var email = storedEmail ? storedEmail : !_this.auth.currentUser ? null : _this.auth.currentUser.email;
    return email ? _this.auth.fetchSignInMethodsForEmail(email) : [];
  });
  (0, _defineProperty2["default"])(this, "authListener", function (next, fallback) {
    return _this.auth.onAuthStateChanged(
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(authUser) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!authUser) {
                  _context2.next = 7;
                  break;
                }

                if (!authUser.isAnonymous) {
                  _context2.next = 4;
                  break;
                }

                _context2.next = 4;
                return _this.user(authUser.uid).set({
                  username: authUser.uid,
                  firstname: "",
                  lastname: "",
                  roles: {
                    GUEST: "GUEST"
                  }
                }, {
                  merge: true
                });

              case 4:
                _this.user(authUser.uid).get().then(
                /*#__PURE__*/
                function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])(
                  /*#__PURE__*/
                  _regenerator["default"].mark(function _callee(snapshot) {
                    var dbUser, idToken;
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            dbUser = snapshot.data();

                            if (authUser.email && dbUser.roles.length && dbUser.roles.includes("GUEST")) {
                              _this.user(authUser.uid).set({
                                email: authUser.email,
                                firstname: _this.fullname(authUser.displayName)[0],
                                lastname: _this.fullname(authUser.displayName)[1] || "",
                                roles: {
                                  USER: "USER"
                                },
                                emailVerified: true
                              }, {
                                merge: true
                              });
                            }

                            _context.next = 4;
                            return authUser.getIdToken();

                          case 4:
                            idToken = _context.sent;
                            next(_objectSpread({
                              uid: authUser.uid,
                              email: authUser.email,
                              idToken: idToken,
                              emailVerified: authUser.emailVerified,
                              providerData: authUser.providerData
                            }, dbUser));

                          case 6:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x2) {
                    return _ref2.apply(this, arguments);
                  };
                }());

                _context2.next = 8;
                break;

              case 7:
                fallback();

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  });
  (0, _defineProperty2["default"])(this, "socialLoginLink", function (provider) {
    return _this.auth.currentUser.linkWithPopup(_this[provider]);
  });
  (0, _defineProperty2["default"])(this, "linkWithCredentials", function (credentials) {
    return _this.auth.currentUser.linkWithCredentials(credentials);
  });
  (0, _defineProperty2["default"])(this, "unlink", function (providerId) {
    return _this.auth.currentUser.unlink(providerId);
  });
  (0, _defineProperty2["default"])(this, "createUserWithEmailAndPassword",
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(userData) {
      var credentials, response;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              credentials = _this.firebaseApp.auth.EmailAuthProvider.credential(userData.email, userData.password);
              _context3.next = 3;
              return _this.firebaseApp.auth().currentUser.linkWithCredential(credentials);

            case 3:
              response = _context3.sent;
              _context3.next = 6;
              return _this.user(_this.firebaseApp.auth().currentUser.uid).set({
                firstname: userData.firstname,
                lastname: userData.lastname,
                email: userData.email,
                roles: {
                  USER: "USER"
                },
                emailVerified: true,
                shopName: _store["default"].get("next:shopname")
              }, {
                merge: true
              });

            case 6:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x3) {
      return _ref3.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "signInWithEmailAndPassword", function (email, password) {
    return _this.auth.signInWithEmailAndPassword(email, password);
  });
  (0, _defineProperty2["default"])(this, "signInWithEmailLink", function (email, url) {
    return _this.auth.signInWithEmailLink(email, url);
  });
  (0, _defineProperty2["default"])(this, "signInWithAnonymous", function () {
    return _this.auth.signInAnonymously();
  });
  (0, _defineProperty2["default"])(this, "signInWithGoogle",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee4() {
    var auth;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return _this.auth.signInWithPopup(_this.googleProvider);

          case 2:
            auth = _context4.sent;

            _this.user(auth.user.uid).set({
              firstname: _this.fullname(auth.user.displayName)[0],
              lastname: _this.fullname(auth.user.displayName)[1] || "",
              email: auth.user.email,
              roles: {
                USER: "USER"
              },
              emailVerified: true,
              shopName: _store["default"].get("next:shopname")
            }, {
              merge: true
            });

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  (0, _defineProperty2["default"])(this, "signInWithFacebook",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee5() {
    var auth;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return _this.auth.signInWithPopup(_this.facebookProvider);

          case 2:
            auth = _context5.sent;

            _this.user(auth.user.uid).set({
              firstname: _this.fullname(auth.additionalUserInfo.profile.name)[0],
              lastname: _this.fullname(auth.additionalUserInfo.profile.name)[1] || "",
              email: auth.additionalUserInfo.profile.email,
              roles: {
                USER: "USER"
              },
              emailVerified: true,
              shopName: _store["default"].get("next:shopname")
            }, {
              merge: true
            });

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
  (0, _defineProperty2["default"])(this, "signInWithTwitter",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee6() {
    var auth;
    return _regenerator["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return _this.auth.signInWithPopup(_this.twitterProvider);

          case 2:
            auth = _context6.sent;

            _this.user(auth.user.uid).set({
              firstname: _this.fullname(auth.additionalUserInfo.profile.name)[0],
              lastname: _this.fullname(auth.additionalUserInfo.profile.name)[1] || "",
              email: auth.additionalUserInfo.profile.email,
              roles: {
                USER: "USER"
              },
              emailVerified: true,
              shopName: _store["default"].get("next:shopname")
            }, {
              merge: true
            });

          case 4:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  })));
  (0, _defineProperty2["default"])(this, "sendSignInLinkToEmail", function (email) {
    return _this.auth.sendSignInLinkToEmail(email, {
      url: _this.config.signInLinkUrl,
      handleCodeInApp: true
    });
  });
  (0, _defineProperty2["default"])(this, "sendEmailVerification", function () {
    return _this.auth.currentUser.sendEmailVerification({
      url: _this.config.confirmationEmailRedirect
    });
  });
  (0, _defineProperty2["default"])(this, "validateSignInWithEmailLink", function (url) {
    return _this.auth.isSignInWithEmailLink(url);
  });
  (0, _defineProperty2["default"])(this, "sendPasswordResetEmail", function (email) {
    return _this.auth.sendPasswordResetEmail(email);
  });
  (0, _defineProperty2["default"])(this, "updatePassword", function (password) {
    return _this.auth.currentUser.updatePassword(password);
  });
  (0, _defineProperty2["default"])(this, "updatePasswordWithAuthentication",
  /*#__PURE__*/
  function () {
    var _ref7 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee7(oldPassword, newPassword) {
      var user, credential;
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              user = _this.auth.currentUser;
              credential = _this.emailAuthProvider.credential(user.email, oldPassword);
              user.reauthenticateWithCredential(credential).then(function () {
                return user.updatePassword(newPassword);
              })["catch"](function (error) {
                return error;
              });

            case 3:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function (_x4, _x5) {
      return _ref7.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "signOut", function () {
    return _this.auth.signOut();
  });
  (0, _defineProperty2["default"])(this, "user", function (uid) {
    return _this.db.doc("users/".concat(uid));
  });
  (0, _defineProperty2["default"])(this, "fullname", function (name) {
    return name.split(/(\s).+\s/).join("").split(" ");
  });
  this.config = authConfig;
  this.firebaseApp = firebaseApp;

  if (typeof window !== "undefined") {
    this.auth = firebaseApp.auth();
    this.db = firebaseApp.firestore();
  }

  this.emailAuthProvider = firebaseApp.auth.EmailAuthProvider;
  this.googleProvider = new firebaseApp.auth.GoogleAuthProvider();
  this.facebookProvider = new firebaseApp.auth.FacebookAuthProvider();
  this.twitterProvider = new firebaseApp.auth.TwitterAuthProvider();
};

var _default = Authentication;
exports["default"] = _default;