"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.AuthContext = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _store = _interopRequireDefault(require("store/dist/store.modern"));

var _authentication = _interopRequireDefault(require("./authentication"));

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var AuthContext = _react["default"].createContext(null);

exports.AuthContext = AuthContext;

var getStoredAuthUser = function getStoredAuthUser() {
  return typeof window !== "undefined" && _store["default"].get("next:user") ? _store["default"].get("next:user") : null;
};

var AuthProvider = function AuthProvider(_ref) {
  var children = _ref.children,
      firebaseApp = _ref.firebaseApp,
      authConfig = _ref.authConfig;
  var auth = new _authentication["default"](authConfig, firebaseApp);
  var authMethods = (0, _utils.filterAuthMethods)(auth);

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      activeSignInMethods = _useState2[0],
      setActiveSignInMethods = _useState2[1];

  var _useState3 = (0, _react.useState)(getStoredAuthUser()),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      authUser = _useState4[0],
      setAuthUser = _useState4[1];

  var _useState5 = (0, _react.useState)(null),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      error = _useState6[0],
      setError = _useState6[1];

  var fetchSignInMethods = (0, _react.useCallback)(
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var methods;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return auth.fetchEmailSignInMethods(authUser === null || authUser === void 0 ? void 0 : authUser.email);

          case 2:
            methods = _context.sent;
            setActiveSignInMethods(methods);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), []);
  (0, _react.useEffect)(function () {
    var unsubscribe = auth.authListener(function (user) {
      _store["default"].set("next:user", user);

      setAuthUser(user);
    }, function () {
      _store["default"].remove("next:user");

      setAuthUser(null);
    });
    return function () {
      unsubscribe();
    };
  }, []);
  (0, _react.useEffect)(function () {
    if (authUser) {
      try {
        fetchSignInMethods();
      } catch (err) {
        setError(err);
      }
    } else {
      try {
        auth.signInWithAnonymous();
      } catch (err) {
        setError(err);
      }
    }
  }, [authUser]);
  var handleSocialLoginLink = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(authProvider) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return auth.socialLoginLink(authProvider);

            case 3:
              fetchSignInMethods();
              _context2.next = 9;
              break;

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2["catch"](0);
              setError(_context2.t0);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 6]]);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }(), []);
  var handleDefaultLoginLink = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(password) {
      var credential;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              credential = auth.emailAuthProvider.credential(authUser.email, password);
              _context3.prev = 1;
              _context3.next = 4;
              return auth.linkWithCredential(credential);

            case 4:
              fetchSignInMethods();
              _context3.next = 10;
              break;

            case 7:
              _context3.prev = 7;
              _context3.t0 = _context3["catch"](1);
              setError(_context3.t0);

            case 10:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[1, 7]]);
    }));

    return function (_x2) {
      return _ref4.apply(this, arguments);
    };
  }(), []);
  var handleDefaultCreateLink = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref5 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(email, password) {
      var credential;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              credential = auth.emailAuthProvider.credential(email, password);
              _context4.prev = 1;
              _context4.next = 4;
              return auth.linkWithCredential(credential);

            case 4:
              fetchSignInMethods();
              _context4.next = 10;
              break;

            case 7:
              _context4.prev = 7;
              _context4.t0 = _context4["catch"](1);
              setError(_context4.t0);

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[1, 7]]);
    }));

    return function (_x3, _x4) {
      return _ref5.apply(this, arguments);
    };
  }(), []);
  var handleUnlink = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref6 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5(providerId) {
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.prev = 0;
              _context5.next = 3;
              return auth.unlink(providerId);

            case 3:
              fetchSignInMethods();
              _context5.next = 9;
              break;

            case 6:
              _context5.prev = 6;
              _context5.t0 = _context5["catch"](0);
              setError(_context5.t0);

            case 9:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[0, 6]]);
    }));

    return function (_x5) {
      return _ref6.apply(this, arguments);
    };
  }(), []);
  return _react["default"].createElement(AuthContext.Provider, {
    value: _objectSpread({
      auth: auth,
      authUser: authUser,
      fetchSignInMethods: fetchSignInMethods,
      activeSignInMethods: activeSignInMethods,
      handleSocialLoginLink: handleSocialLoginLink,
      handleDefaultLoginLink: handleDefaultLoginLink,
      handleDefaultCreateLink: handleDefaultCreateLink,
      handleUnlink: handleUnlink,
      error: error
    }, authMethods)
  }, children);
};

var _default = (0, _react.memo)(AuthProvider);

exports["default"] = _default;