"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterAuthMethods = exports.needsEmailVerification = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var needsEmailVerification = function needsEmailVerification(authUser) {
  return authUser && !authUser.emailVerified && authUser.providerData.map(function (provider) {
    return provider.providerId;
  }).includes("password");
};

exports.needsEmailVerification = needsEmailVerification;

var filterAuthMethods = function filterAuthMethods(authClass) {
  var auth = authClass.auth,
      config = authClass.config,
      firebaseApp = authClass.firebaseApp,
      db = authClass.db,
      emailAuthProvider = authClass.emailAuthProvider,
      googleProvider = authClass.googleProvider,
      facebookProvider = authClass.facebookProvider,
      twitterProvider = authClass.twitterProvider,
      user = authClass.user,
      authMethods = (0, _objectWithoutProperties2["default"])(authClass, ["auth", "config", "firebaseApp", "db", "emailAuthProvider", "googleProvider", "facebookProvider", "twitterProvider", "user"]);
  return authMethods;
};

exports.filterAuthMethods = filterAuthMethods;