"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DatabaseContext = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _database = _interopRequireDefault(require("./database"));

var DatabaseContext = _react["default"].createContext(null);

exports.DatabaseContext = DatabaseContext;

var DatabaseProvider = function DatabaseProvider(_ref) {
  var children = _ref.children,
      firebaseApp = _ref.firebaseApp;
  var database = new _database["default"](firebaseApp);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isLoading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      addresses = _useState4[0],
      setAddresses = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      wishlist = _useState6[0],
      setWishlist = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      sharedWishlist = _useState8[0],
      setSharedWishlist = _useState8[1];

  var _useState9 = (0, _react.useState)([]),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      allWishlists = _useState10[0],
      setAllWishlists = _useState10[1];

  var _useState11 = (0, _react.useState)({}),
      _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
      userData = _useState12[0],
      setUserData = _useState12[1];

  var addUserData = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(uid, data) {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);
              _context.next = 3;
              return database.addUserData({
                userId: uid,
                data: data
              });

            case 3:
              setLoading(false);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }());
  var wishlistSubscribe = (0, _react.useCallback)(function (uid, wishlistName, setWishlistCB) {
    setLoading(true);
    var unsubscribe = database.wishlistSubscribe(uid, wishlistName, setWishlistCB ? setWishlistCB : setWishlist);
    setLoading(false);
    return unsubscribe;
  });
  var sharedWishlistSubscribe = (0, _react.useCallback)(function (token, setWishlistCB) {
    setLoading(true);
    var decoded = atob(token);

    var _decoded$split = decoded.split("/"),
        _decoded$split2 = (0, _slicedToArray2["default"])(_decoded$split, 2),
        uid = _decoded$split2[0],
        wishlistName = _decoded$split2[1];

    var unsubscribe = database.wishlistSubscribe(uid, wishlistName, setWishlistCB ? setWishlistCB : setSharedWishlist);
    setLoading(false);
    return unsubscribe;
  });
  var getAllWishlistNames = (0, _react.useCallback)(function (uid) {
    setLoading(true);
    var unsubscribe = database.getAllWishlistNames(uid, setAllWishlists);
    setLoading(false);
    return unsubscribe;
  });
  var addToWishlist = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(uid, item, wishlistName) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              setLoading(true);
              _context2.next = 3;
              return database.addToWishlist(uid, item, wishlistName);

            case 3:
              setLoading(false);

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x3, _x4, _x5) {
      return _ref3.apply(this, arguments);
    };
  }());
  var removeFromWishlist = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(uid, item, wishlistName) {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              setLoading(true);
              _context3.next = 3;
              return database.removeFromWishlist(uid, item, wishlistName);

            case 3:
              setLoading(false);

            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x6, _x7, _x8) {
      return _ref4.apply(this, arguments);
    };
  }());
  var shareWishlist = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref5 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(uid, wishlistName) {
      var res;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              setLoading(true);
              _context4.next = 3;
              return database.shareWishlist(uid, wishlistName);

            case 3:
              res = _context4.sent;
              setLoading(false);
              return _context4.abrupt("return", btoa("".concat(uid, "/").concat(wishlistName)));

            case 6:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x9, _x10) {
      return _ref5.apply(this, arguments);
    };
  }());
  var setNewPrimaryAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref6 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5(userId, newPrimaryAddressId) {
      var promises;
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              promises = addresses.map(function (address) {
                if (address.id !== newPrimaryAddressId) {
                  return database.updateShippingAddress({
                    userId: userId,
                    isPrimary: false,
                    addressId: address.id
                  });
                }
              });
              _context5.next = 3;
              return Promise.all(promises);

            case 3:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function (_x11, _x12) {
      return _ref6.apply(this, arguments);
    };
  }());
  var updateAddress = (0, _react.useCallback)(function (_ref7) {
    var userId = _ref7.userId,
        addressId = _ref7.addressId,
        addressDetails = _ref7.addressDetails,
        isPrimary = _ref7.isPrimary;
    return database.updateShippingAddress({
      userId: userId,
      addressId: addressId,
      addressDetails: addressDetails,
      isPrimary: isPrimary
    });
  });
  var addAddress = (0, _react.useCallback)(function (_ref8) {
    var userId = _ref8.userId,
        addressDetails = _ref8.addressDetails,
        isPrimary = _ref8.isPrimary;
    return database.saveShippingAddress(userId, addressDetails, isPrimary);
  });
  var saveAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref9 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee6(_ref10) {
      var userId, addressDetails, addressId, makePrimary, newPrimaryAddressId, newAddress;
      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              userId = _ref10.userId, addressDetails = _ref10.addressDetails, addressId = _ref10.addressId, makePrimary = _ref10.makePrimary;
              setLoading(true);
              newPrimaryAddressId = addressId;

              if (!addressId) {
                _context6.next = 8;
                break;
              }

              _context6.next = 6;
              return updateAddress({
                userId: userId,
                addressId: addressId,
                addressDetails: addressDetails,
                isPrimary: makePrimary
              });

            case 6:
              _context6.next = 12;
              break;

            case 8:
              _context6.next = 10;
              return addAddress({
                userId: userId,
                addressDetails: addressDetails,
                isPrimary: makePrimary
              });

            case 10:
              newAddress = _context6.sent;
              newPrimaryAddressId = newAddress.id;

            case 12:
              if (!makePrimary) {
                _context6.next = 15;
                break;
              }

              _context6.next = 15;
              return setNewPrimaryAddress(userId, newPrimaryAddressId);

            case 15:
              setLoading(false);

            case 16:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function (_x13) {
      return _ref9.apply(this, arguments);
    };
  }());
  var addressesSubscribe = (0, _react.useCallback)(function (uid) {
    setLoading(true);
    var unsubscribe = database.shippingAddressesSubscribe(uid, setAddresses);
    setLoading(false);
    return unsubscribe;
  });
  var deleteAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref11 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee7(userId, addressId) {
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              setLoading(true);
              database.deleteShippingAddress({
                userId: userId,
                addressId: addressId
              });
              setLoading(false);

            case 3:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function (_x14, _x15) {
      return _ref11.apply(this, arguments);
    };
  }());
  var userDataSubscribe = (0, _react.useCallback)(function (uid) {
    setLoading(true);
    var unsubscribe = database.docSubscribe("/users/".concat(uid), setUserData);
    setLoading(false);
    return unsubscribe;
  });
  var providerValue = (0, _react.useMemo)(function () {
    return {
      database: database,
      allWishlists: allWishlists,
      getAllWishlistNames: getAllWishlistNames,
      wishlist: wishlist,
      sharedWishlist: sharedWishlist,
      wishlistSubscribe: wishlistSubscribe,
      sharedWishlistSubscribe: sharedWishlistSubscribe,
      addToWishlist: addToWishlist,
      removeFromWishlist: removeFromWishlist,
      shareWishlist: shareWishlist,
      saveAddress: saveAddress,
      addressesSubscribe: addressesSubscribe,
      addresses: addresses,
      deleteAddress: deleteAddress,
      addUserData: addUserData,
      userDataSubscribe: userDataSubscribe,
      userData: userData,
      isLoading: isLoading
    };
  }, [{
    database: database,
    allWishlists: allWishlists,
    getAllWishlistNames: getAllWishlistNames,
    wishlist: wishlist,
    sharedWishlist: sharedWishlist,
    wishlistSubscribe: wishlistSubscribe,
    sharedWishlistSubscribe: sharedWishlistSubscribe,
    addToWishlist: addToWishlist,
    removeFromWishlist: removeFromWishlist,
    shareWishlist: shareWishlist,
    saveAddress: saveAddress,
    addressesSubscribe: addressesSubscribe,
    addresses: addresses,
    deleteAddress: deleteAddress,
    addUserData: addUserData,
    userDataSubscribe: userDataSubscribe,
    userData: userData,
    isLoading: isLoading
  }]);
  return _react["default"].createElement(DatabaseContext.Provider, {
    value: providerValue
  }, children);
};

var _default = (0, _react.memo)(DatabaseProvider);

exports["default"] = _default;