"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CUSTOMER_ACCESS_TOKEN_CREATE = exports.SUBSCRIBER_UPDATE = exports.SUBSCRIBER_CREATE = exports.CUSTOMER_ACCOUNT_ACTIVATE = exports.CUSTOMER_PASSWORD_UPDATE = exports.CUSTOMER_UPDATE = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation CUSTOMER_ACCESS_TOKEN_CREATE($shopName: String!, $idToken: String!) {\n    customerAccessTokenCreate(shopName: $shopName, idToken: $idToken) {\n      accessToken\n      expiresAt\n    }\n  }\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation SUBSCRIBER_UPDATE(\n    $shopName: String!\n    $email: String!\n    $customerUpdates: CustomerUpdateInput!\n  ) {\n    subscriberCreate(\n      shopName: $shopName\n      email: $email\n      customerUpdates: $customerUpdates\n    ) {\n      id\n      email\n      acceptsMarketing\n    }\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation SUBSCRIBER_CREATE($shopName: String!, $email: String!) {\n    subscriberCreate(shopName: $shopName, email: $email) {\n      id\n      email\n      acceptsMarketing\n    }\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation CUSTOMER_ACCOUNT_ACTIVATE(\n    $shopName: String!\n    $customerId: String!\n    $activationToken: String!\n    $password: String!\n  ) {\n    customerAccountActivate(\n      shopName: $shopName\n      customerId: $customerId\n      activationToken: $activationToken\n      password: $password\n    )\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation CUSTOMER_PASSWORD_UPDATE(\n    $shopName: String!\n    $customerId: String!\n    $resetToken: String!\n    $password: String!\n  ) {\n    customerPasswordUpdate(\n      shopName: $shopName\n      customerId: $customerId\n      resetToken: $resetToken\n      password: $password\n    )\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation CUSTOMER_UPDATE(\n    $shopName: String!\n    $customerUpdates: CustomerUpdateInput!\n    $idToken: String!\n  ) {\n    customerUpdate(\n      shopName: $shopName\n      customerUpdates: $customerUpdates\n      idToken: $idToken\n    ) {\n      id\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var CUSTOMER_UPDATE = (0, _graphqlTag["default"])(_templateObject());
exports.CUSTOMER_UPDATE = CUSTOMER_UPDATE;
var CUSTOMER_PASSWORD_UPDATE = (0, _graphqlTag["default"])(_templateObject2());
exports.CUSTOMER_PASSWORD_UPDATE = CUSTOMER_PASSWORD_UPDATE;
var CUSTOMER_ACCOUNT_ACTIVATE = (0, _graphqlTag["default"])(_templateObject3());
exports.CUSTOMER_ACCOUNT_ACTIVATE = CUSTOMER_ACCOUNT_ACTIVATE;
var SUBSCRIBER_CREATE = (0, _graphqlTag["default"])(_templateObject4());
exports.SUBSCRIBER_CREATE = SUBSCRIBER_CREATE;
var SUBSCRIBER_UPDATE = (0, _graphqlTag["default"])(_templateObject5());
exports.SUBSCRIBER_UPDATE = SUBSCRIBER_UPDATE;
var CUSTOMER_ACCESS_TOKEN_CREATE = (0, _graphqlTag["default"])(_templateObject6());
exports.CUSTOMER_ACCESS_TOKEN_CREATE = CUSTOMER_ACCESS_TOKEN_CREATE;